unit pagefound;

interface

uses
  Shellapi, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,LinkLabel,utils, ComCtrls, ExtCtrls;

type
  TUserResponse = record
   relevance: integer;
   hadEnough: boolean;
  end;

  TfrmPageFound = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Memo1: TMemo;
    pnlRateRelevance: TPanel;
    pnlButtons: TPanel;
    cbEnough: TCheckBox;
    pnlFeedback: TPanel;
    lblTotallyRelevant: TLabel;
    lblIrrelevant: TLabel;
    gbRelevance: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    RadioButton11: TRadioButton;
    RadioButton12: TRadioButton;
    RadioButton13: TRadioButton;
    RadioButton14: TRadioButton;
    RadioButton15: TRadioButton;
    RadioButton16: TRadioButton;
    RadioButton17: TRadioButton;
    RadioButton18: TRadioButton;
    RadioButton19: TRadioButton;
    RadioButton20: TRadioButton;
    RadioButton21: TRadioButton;
    lblRateHeading: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    btnClose: TButton;
    btnShowRelevance: TButton;
    procedure FormCreate(Sender: TObject);
    procedure RadioButton13Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnShowRelevanceClick(Sender: TObject);
  private
    { Private declarations }
    frmFeeds: TForm;
  public
    { Public declarations }
    procedure setDetails(formCaption: string; _url: string; title: string; messageText: string; showRelevanceRating: boolean);
    function getRelevance: integer;
    procedure setFeedsForm(_frmFeeds: TForm);
  end;

var
  frmPageFound: TfrmPageFound;

implementation

uses feeds;

{$R *.dfm}

procedure TfrmPageFound.setFeedsForm(_frmFeeds: TForm);
begin
   frmFeeds := _frmFeeds;
end;

procedure TfrmPageFound.btnShowRelevanceClick(Sender: TObject);
var
   wordsList: TStringList;
   frmFeedsCasted: TfrmFeeds;
   words: string;
begin
   Screen.Cursor := crHourglass;
   frmFeedsCasted := (frmFeeds as TfrmFeeds);
   words := label1.Caption + ' ' + memo1.text;
   wordsList := frmFeedsCasted.getCleanWordList(words);
   try
      showmessage('Simple relevance='+inttostr(frmFeedsCasted.checkSimpleRelevance(wordsList))+'%, ' +
         'Relationship relevance='+inttostr(frmFeedsCasted.checkRelevanceInRelTable(wordsList))+'%, ' +
         'Overall relevance='+inttostr(frmFeedsCasted.checkRelevance(words))+'%');
   finally
      wordsList.free;
      Screen.Cursor := crDefault;
   end;
end;

procedure TfrmPageFound.FormCreate(Sender: TObject);
const
   hint = 'As you tell Webu how relevant you find each article, it will gradually learn about the kind of articles that interest you ' + chr(13) + chr(10) +
      ' and will start to show you similar articles in future.' + chr(13) + chr(10) +
      'The more feedback you provide, the more it will learn about your interests ' + chr(13) + chr(10) +
      'and the better it will get at showing you relevant content';
begin
   pnlFeedback.Hint := hint;
   lblRateHeading.Hint := hint;
   lblIrrelevant.Hint := hint;
   lblTotallyRelevant.Hint := hint;
   gbRelevance.Hint := hint;
end;

procedure TfrmPageFound.setDetails(formCaption: string; _url: string; title: string; messageText: string; showRelevanceRating: boolean);
const
   margin = 10;
begin
   if showRelevanceRating then
      btnClose.hint := 'Close this window and leave this article unrated'
   else
      btnClose.hint := 'Close this window';

   pnlRateRelevance.Visible := showRelevanceRating;
   self.Caption := formCaption;
   label1.caption := removeHTML(title);
   memo1.Text := removeHTML(messageText);

   with TLinkLabel.create(self) do
   begin
      parent := pnlButtons;
      Caption := _url;
      URL := _url;
      top := margin;
      left := margin;
      visitedColor := clBlue;
      show;
   end;
end;

procedure TfrmPageFound.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   // note - form's "KeyPreview" must be set to true or this event isn't fired
   btnShowRelevance.visible := ((ssShift in Shift) and (ssAlt in Shift));
end;

function TfrmPageFound.getRelevance: integer;
var
   i: integer;
   rb: TRadioButton;
begin
   for i := 0 to gbRelevance.ControlCount - 1 do
   begin
      if gbRelevance.Controls[i].ClassType = TRadioButton then
      begin
         rb := (gbRelevance.Controls[i] as TRadioButton);
         if rb.Checked then
         begin
            result := rb.Tag;
            exit;
         end;
      end;
   end;
   result := 0; // no rating given by user      
end;

procedure TfrmPageFound.RadioButton13Click(Sender: TObject);
begin
   sleep(300); // so the user can see their choice - it looks better than vanishing immediately
   close;
end;

end.
